$(function(){
	
    var dropbox = $('#dropbox'),
    message = $('.message', dropbox);
	
    dropbox.filedrop({
        // The name of the $_FILES entry:
        fallback_id: 'imgUpload',
        paramname:'pic',
        
        maxfiles: 100,
        maxfilesize: 10,
        url: 'upload',
		
        uploadFinished:function(i,file,response){
            $.data(file).addClass('done');
        },
		
        error: function(err, file) {
            switch(err) {
                case 'BrowserNotSupported':
                    showMessage('Your browser does not support HTML5 file uploads!');
                    break;
                case 'TooManyFiles':
                    this.showError('Too many files! Please select 100 at most! (configurable)');
                    break;
                case 'FileTooLarge':
                    this.showError(file.name+' is too large! Please upload files up to 10mb (configurable).');
                    break;
                default:
                    break;
            }
        },
        
        showError: function(msg) {
            console.log(msg);
        },
		
        // Called before each upload is started
        beforeEach: function(file){
            name = getGalleryName();
            if(!file.type.match(/^image\//)){
                this.showError('Only images are allowed!');
				
                // Returning false will cause the
                // file to be rejected
                return false;
            }
            this.data = {
                "galleryName": name
            };
        },
		
        uploadStarted:function(i, file, len){
            createImage(file);
        },
		
        progressUpdated: function(i, file, progress) {
            $.data(file).find('.progress').width(progress/2);
        }
    	 
    });
	
    var template = '<div class="preview">'+
    '<span class="imageHolder">'+
    '<img />'+
    '<span class="uploaded"></span>'+
    '</span>'+
    '<div class="progressHolder">'+
    '<div class="progress"></div>'+
    '</div>'+
    '</div>'; 
	
	
    function createImage(file){

        var preview = $(template), 
        image = $('img', preview);
			
        var reader = new FileReader();
		
        image.width = 50;
        image.height = 50;
		
        reader.onload = function(e){
			
            // e.target.result holds the DataURL which
            // can be used as a source of the image:
			
            image.attr('src',e.target.result);
        };
		
        // Reading the file as a DataURL. When finished,
        // this will trigger the onload function above:
        reader.readAsDataURL(file);
		
        //message.hide();
        preview.appendTo(dropbox.children(".drop_here")[0]);
		
        // Associating a preview container
        // with the file, using jQuery's $.data():
        $.data(file,preview);
    }

    function showMessage(msg){
        message.html(msg);
    }
});